/// Copyright (c) 2010 Ruben Penalva. All rights reserved.
/// Redistribution and use in source and binary forms, with or without modification, 
/// are permitted provided that the following conditions are met:
///    1. Redistributions of source code must retain the above copyright notice, this 
///    list of conditions and the following disclaimer.
///    2. Redistributions in binary form must reproduce the above copyright notice,
///    this list of conditions and the following disclaimer in the documentation and/or
///    other materials provided with the distribution.
///    3. The name of the author may not be used to endorse or promote products derived
///    from this software without specific prior written permission.
///
/// THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
/// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
/// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, 
/// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
/// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
/// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
/// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
/// THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#include "Thread.h"

#include "IThreadCallable.h"
#include <boost\ref.hpp>

using namespace TestFrameWork;

Thread::Thread(IThreadCallablePtr threadCallable, boost::barrier& preSetupBarrier,
			   boost::barrier& postSetupBarrier, int elapsedTimeSamplesCount)	:	m_timer(elapsedTimeSamplesCount),
																					m_callable(threadCallable), 
																					m_stop(false), m_initBarrier(2),
																					m_preSetupBarrier(preSetupBarrier),
																					m_postSetupBarrier(postSetupBarrier)
{
	/// A ref its passed because in that way it doesnt create another
	/// instance of the object.
	m_thread.reset(new boost::thread(boost::ref(*this)));

	m_initBarrier.wait();
}

Thread::~Thread(void)
{
}

void Thread::operator()(void)
{
	m_callable->Initialize();
	m_initBarrier.wait();

	m_preSetupBarrier.wait();
	m_callable->Setup();
	m_postSetupBarrier.wait();

	while (!m_stop)
	{
		m_callable->Run(m_timer.ElapsedTime());
	}
}

void Thread::Join(void)
{
	m_thread->join();
}

void Thread::Stop(void)
{
	m_stop = true;
}

float Thread::MeanElapsedTime(void) const
{
	return m_timer.MeanElapsedTime();
}